unit uCheckersTypes;

interface

uses OMEGA,omegapng;

type tPossibleMoves=Set Of 1..4;
     tPMoves=array [1..4] of boolean;

     tCell=record
      Side:byte;        // 
      King:boolean;     // ?
      PM:tPossibleMoves;//  
     end;

     tChessBoard=Object   // 
      Cells:array [-1..10,-1..10] of tCell;
      BCell,WCell:byte;  //-    
      Moves:array [1..4,1..2] of integer; // 
      //   
      Board:PTexture;
      DarkBoard,LightBoard:PTexture;
      DarkCell,LightCell,
      DarkKingCell,LightKingCell:PTexture;
      BoardTexture:boolean;

      procedure InitBoard;
      procedure FillBoard; //  
      procedure Clear;
      procedure MoveCell(x,y,Dir:byte);     //   
      procedure Strike(x,y,Dir:byte);       //  
      function FindMove(x,y:byte):tPMoves;  // 
      function CanStrike(x,y:byte):boolean; //  
      function FindStrike(x,y:byte):tPMoves;//  
      procedure DrawBoard(x,y:integer);
     End;

implementation

uses uAll;

procedure tChessBoard.InitBoard;
begin
DarkBoard:=Tex_LoadFromFile('Data\Board\DarkBoard.jpg',-1,TEX_DEFAULT_2D );     // 
LightBoard:=Tex_LoadFromFile('Data\Board\LightBoard.jpg',-1,TEX_DEFAULT_2D );   // 
DarkCell:=Tex_LoadPNGFromFile('Data\Cell\Dark.png',-1,TEX_DEFAULT_2D);          // 
LightCell:=Tex_LoadPNGFromFile('Data\Cell\Light.png',-1,TEX_DEFAULT_2D);        // 
DarkKingCell:=Tex_LoadPNGFromFile('Data\Cell\DarkKing.png',-1,TEX_DEFAULT_2D);  // 
LightKingCell:=Tex_LoadPNGFromFile('Data\Cell\LightKing.png',-1,TEX_DEFAULT_2D);// 
Board:=Tex_CreateZero(512,512,TEX_DEFAULT_2D );                                 //
BoardTexture:=false;                                                            //   
//   
//1- 
Moves[1,1]:=1;  Moves[1,2]:=-1;
//2- 
Moves[2,1]:=-1; Moves[2,2]:=-1;
//3- 
Moves[3,1]:=-1; Moves[3,2]:=1;
//4- 
Moves[4,1]:=1;  Moves[4,2]:=1;
end;

procedure tChessBoard.DrawBoard(x,y:integer);
var ix,iy:byte;
begin
//    
if  not BoardTexture then begin
//    
 Tex_BeginRenderIn(Board,true,true,false);
//       
//..         ,
//      - ,
//             
 for iy:=1 to 8 do
  for ix:=1 to 8 do begin
   Case Cells[ix,iy].Side of
    0:if ((ix mod 2=1) and (iy mod 2=1)) or ((ix mod 2=0) and (iy mod 2=0))
       then SSprite_Draw(DarkBoard,ix*64-64,512-iy*64,64,64) else SSPrite_Draw(LightBoard,ix*64-64,512-iy*64,64,64);
    1:begin
       if ((ix mod 2=1) and (iy mod 2=1)) or ((ix mod 2=0) and (iy mod 2=0))
        then SSprite_Draw(DarkBoard,ix*64-64,512-iy*64,64,64) else SSPrite_Draw(LightBoard,ix*64-64,512-iy*64,64,64);
       if Cells[ix,iy].King then SSprite_Draw(LightKingCell,ix*64-64,512-iy*64,64,64)
        else SSprite_Draw(LightCell,ix*64-64,512-iy*64,64,64);
    end;
    2:begin
       if ((ix mod 2=1) and (iy mod 2=1)) or ((ix mod 2=0) and (iy mod 2=0))
        then SSprite_Draw(DarkBoard,ix*64-64,512-iy*64,64,64) else SSPrite_Draw(LightBoard,ix*64-64,512-iy*64,64,64);
       if Cells[ix,iy].King then SSprite_Draw(DarkKingCell,ix*64-64,512-iy*64,64,64)
        else SSprite_Draw(DarkCell,ix*64-64,512-iy*64,64,64);
    end;
   End;
  end;
//   
 Tex_EndRenderIn;
// ,   
 BoardTexture:=true;
end;
//    
// 
Pr2D_Rect(x-25,y-25,562,562,$53B2DE,255,PR_FILL);
Pr2D_Rect(x-5,y-5,522,522,$002464,255,PR_FILL);
//   
SSprite_Draw(Board,x,y,512,512);
end;

procedure tChessBoard.FillBoard;
var ix,iy:integer;
    W,B:tCell;
begin
//   
W.Side:=1; W.King:=false; W.PM:=[3,4];
B.Side:=2; B.King:=false; B.PM:=[1,2];
// 
for iy:=4 to 5 do
 for ix:=1 to 8 do begin
  Cells[ix,iy].Side:=0;
 end;
// 
for iy:=1 to 3 do
 for ix:=1 to 8 do begin
  if (ix mod 2=0) and (iy mod 2=0) then Cells[ix,iy]:=W;
  if (ix mod 2=1) and (iy mod 2=1) then Cells[ix,iy]:=W;
 end;
// 
for iy:=8 downto 6 do
 for ix:=1 to 8 do begin
  if (ix mod 2=0) and (iy mod 2=0) then Cells[ix,iy]:=B;
  if (ix mod 2=1) and (iy mod 2=1) then Cells[ix,iy]:=B;
 end;
//   
//          
for ix:=-1 to 10 do begin
 Cells[ix,-1]:=B; Cells[ix,0]:=B;
 Cells[ix,9]:=B;  Cells[ix,10]:=B;
 Cells[-1,ix]:=B; Cells[0,ix]:=B;
 Cells[9,ix]:=B;  Cells[10,ix]:=B;
end;
// -    
BCell:=12;
WCell:=12;
end;

procedure tChessBoard.Clear;
var i1,i2:integer;
begin
for i1:=-1 to 10 do
 for i2:=-1 to 10 do Cells[i1,i2].Side:=0;
end;

procedure tChessBoard.MoveCell(x,y,Dir:byte);
begin
Case Dir of
 1:begin
         Cells[x+Moves[1,1],y+Moves[1,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
 end;
 2:begin
         Cells[x+Moves[2,1],y+Moves[2,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
 end;
 3:begin
         Cells[x+Moves[3,1],y+Moves[3,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
 end;
 4:begin
         Cells[x+Moves[4,1],y+Moves[4,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
 end;
End;
BoardTexture:=false;
end;

procedure tChessBoard.Strike(x,y,Dir:byte);
begin
Case Dir of
 1:begin
         Cells[x+2*Moves[1,1],y+2*Moves[1,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
         if Cells[x+Moves[1,1],y+Moves[1,2]].Side=1 then BCell:=BCell-1 else WCell:=WCell-1;
         Cells[x+Moves[1,1],y+Moves[1,2]].Side:=0;
 end;
 2:begin
         Cells[x+2*Moves[2,1],y+2*Moves[2,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
         if Cells[x+Moves[1,1],y+Moves[1,2]].Side=1 then BCell:=BCell-1 else WCell:=WCell-1;
         Cells[x+Moves[2,1],y+Moves[2,2]].Side:=0;
 end;
 3:begin
         Cells[x+2*Moves[3,1],y+2*Moves[3,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
         if Cells[x+Moves[1,1],y+Moves[1,2]].Side=1 then BCell:=BCell-1 else WCell:=WCell-1;
         Cells[x+Moves[3,1],y+Moves[3,2]].Side:=0;
 end;
 4:begin
         Cells[x+2*Moves[4,1],y+2*Moves[4,2]]:=Cells[x,y];
         Cells[x,y].Side:=0;
         if Cells[x+Moves[1,1],y+Moves[1,2]].Side=1 then BCell:=BCell-1 else WCell:=WCell-1;         
         Cells[x+Moves[4,1],y+Moves[4,2]].Side:=0;
 end;
End;
BoardTexture:=false;
end;

function tChessBoard.FindMove(x: Byte; y: Byte):tPMoves;
var i1:integer;
begin
for i1:=1 to 4 do FindMove[i1]:=false;
for i1:=1 to 4 do
 if i1 in Cells[x,y].PM then FindMove[i1]:=Cells[x+Moves[i1,1],y+Moves[i1,2]].Side=0;
end;

function tChessBoard.CanStrike(x: Byte; y: Byte):boolean;
label L1;
var i1:integer;
begin
for i1:=1 to 4 do begin
 if (Cells[x+Moves[i1,1],y+Moves[i1,2]].Side<>0)
 and (Cells[x,y].Side<>Cells[x+Moves[i1,1],y+Moves[i1,2]].Side) then
  if Cells[x+2*Moves[i1,1],y+2*Moves[i1,2]].Side=0 then begin
    CanStrike:=true;
    GoTO L1;
   end;
end;
L1:
end;

function tChessBoard.FindStrike(x: Byte; y: Byte):tPMoves;
var i1:integer;
begin
for i1:=1 to 4 do FindStrike[i1]:=false;
for i1:=1 to 4 do begin
 if Cells[x+Moves[i1,1],y+Moves[i1,2]].Side<>0 then
  if Cells[x,y].Side<>Cells[x+Moves[i1,1],y+Moves[i1,2]].Side then
    FindStrike[i1]:=Cells[x+2*Moves[i1,1],y+2*Moves[i1,2]].Side=0;
end;
end;

end.
