{
           .
}
unit DGuiBuilder;

interface

uses
  DMath,

  DGuiCore,
  DGuiCommon;

type
// () ====
TGuiImage = Integer;
TOnClosed = Integer;
TOnEnter = Integer;
// ==============

TGuiBuilder = class
private
  FGui: TGui;
  FStyle: String;
  FCurrent: TWidget;
  FOwner: TWidget;
public
  constructor Create(Gui: TGui);
  procedure SetStyle(Name: String);
  procedure SetOwner(Owner: TWidget);
  function _Label(Pos, Size: TVec2f; Text: String): TGuiLabel;
  function Button(Rect: TRect;
                  Text: String;  
                  OnClick: TOnClick): TGuiButton; overload;
  function Button(Rect: TRect;
                  Image: TGuiImage; 
                  OnClick: TOnClick): TWidget; overload;
  function Edit(Rect: TRect; TOnEnter: TOnEnter; Text: String = ''): TWidget;
  function CheckBox(Rect: TRect; Text: String; State: Boolean = False): TWidget;
  // ,    StartWindow  EndWindow -   
  function StartWindow(Rect: TRect; Name: String; OnClosed: TOnClosed): TWidget;
  procedure EndWindow;
end;

implementation

constructor TGuiBuilder.Create(Gui: TGui);
begin
  FGui := Gui;
  FOwner := Gui.Root;
end;

procedure TGuiBuilder.SetStyle(Name: String);
begin
  FStyle := Name;
end;

procedure TGuiBuilder.SetOwner(Owner: TWidget);
begin
  FOwner := Owner;
end;

function TGuiBuilder._Label(Pos, Size: TVec2f; Text: String): TGuiLabel;
begin
  Result := TGuiLabel.Create(FGui, Text, FStyle);
  FGui.Link(FOwner, Result);
  Result.Local := Pos;
  Result.Size := Size;
  Result._Label.Font := 'default';
  Result._Label.Text := Text;
end;

function TGuiBuilder.Button(Rect: TRect; 
                            Text: String; 
                            OnClick: TOnClick): TGuiButton;
begin
  Result := TGuiButton.Create(FGui, Text, FStyle);
  Result.LocalRect := Rect;
  FGui.Link(FOwner, Result);
end;

function TGuiBuilder.Button(Rect: TRect;
                            Image: TGuiImage; 
                            OnClick: TOnClick): TWidget;
begin
  Result := nil
end;

function TGuiBuilder.Edit;
begin
  Result := nil;
end;

function TGuiBuilder.CheckBox;
begin
  Result := nil;
end;

function TGuiBuilder.StartWindow;
begin
  Result := nil;

  FCurrent := Result;
end;

procedure TGuiBuilder.EndWindow;
begin
  FCurrent := nil
end;

end.
