//14.04.2009 [+] TCriticalSection
//27.03.2009 [+] ToStr
//12.12.2008 [+] SetBit, GetBit
//17.10.2008 [*] fixed uninherited TData.Destroy
//           [*] fixed signed and unsifgned addition in TData.seekCur and TData.getVar
//25.06.2008 [+] TTimer.SetInterval
unit DUtils;

interface

Uses
  Windows;

Type
  Float = Single;

  TProcObj = procedure of object;

  PArrayOfBytes = ^TArrayOfBytes;
  TArrayOfBytes = array[0..1] of Byte;
  TArray4OfByte = array[0..3] of Byte;
  TArray16OfSingle = array[0..15] of Single;

  PArrayOfByte = PArrayOfBytes;
  TArrayOfByte = TArrayOfBytes;

Function IntToStr(Value: integer): string;
Function StrToInt(Value: string): integer;
Function StrToIntDef(Value: String; Def: integer): integer;
Function StrToFloat(S: String): Single;
Function FloatToStr(F: Single): String;
function CharArrToStr(const C : Array of Char) : String;
Function HexToInt(S: String): Integer;
Function IntToHex(Value: Integer; Digits: Integer = 0): String;
Function FileExist(Filename: string): boolean;
Procedure CreateFile(FileName: string);
Procedure DeleteFile(Filename: string);
Function GetTimer: integer;
//     
Function AnsiLowerCase(const S: string): string;

function ToStr(V: array of Const): string;

Function GetBit(B: Byte; ID: Integer): Boolean;
Function SetBit(B: Byte; ID: Integer; Flag: Boolean): Byte;

Type
TField = record
  Name, Value: String;
end;

TSection = record
  Name: String;
  Fields: array of TField;
end;

TIniFile = class//{{{
private
  FLoaded: Boolean;
  FileName: String;
  Sections: array of TSection;
  Class Function FindFieldInSection(Var Section: TSection; Field: string): integer;
  Class Procedure SetFieldInSection(Var Section: TSection; Field: string; Value: string);
  Class Function GetFieldInSection(Var Section: TSection; Field: string): string;
  Function FindSection(Section: string): integer;
  Procedure AddSection(Section: string);
  Procedure Clear;
public
  Constructor Create(FileName: String);
  Destructor Destroy; override;
  Procedure Update;
  Procedure Flush;
  Function GetField(Section, Field: String): String;
  Procedure SetField(Section, Field, Value: String);
  Property Loaded: Boolean read FLoaded;
  Property Fields[Index1, Index2: String]: String read GetField write SetField; default;
end;
//}}}
//@class  -       .
TTimer = class
private
  Old: Integer;
  Int: Integer;
public
  Constructor Create(Interval: Integer);
  Procedure SetInterval(Interval: Integer);
  Function Pop: Boolean;
  Procedure Reset;
end;

//@class       (  TStream)
TData = class
  Bytes: array of Byte;
  Len: cardinal;
  Pos: cardinal;
  Constructor Create(Filename: string);
  Destructor Destroy; override;
  Function IsEmpty: boolean;
  Procedure GetVar(p: pointer; size: integer);
  Function GetByte: byte;
  Function GetWord: word;
  Function GetInteger: integer;
  Function GetCardinal: cardinal;
  Function GetFloat: single;
  Function GetString: string;
  Function GetPChar: string;
  Function GetPtr: pointer;
  Function SeekCur(delta: integer): integer;
  Function SeekAbs(offs: integer): integer;
  Function Ready: Boolean;
  procedure Clear;
  procedure WriteToFile(FileName: string);
  procedure WriteVar(P: Pointer; Size: Integer);
  procedure WriteInt(I: Integer);
  procedure WriteByte(B: Byte);
  procedure WriteFloat(F: Float);  
end;

// @class ,     :)
TTextData = class
private
  FPos: Integer;
  FLines: Array Of String;
public
  Constructor Create(FileName: String; Br: String);
  Procedure SeekAbs(NewPos: Integer);
  Procedure SeekCur(Delta: Integer);
  Procedure Rewind;
  Function LinePos: Integer;
  Function LinesCount: Integer;
  Function NextLine: String;
  Function IsEmpty: Boolean;
  Function GetLine(Index: Integer): String;
  Property Lines[Index: Integer]: String read GetLine; default;
end;

TCriticalSection = class//{{{
private
  FCS: TRTLCriticalSection;
  FLocked: Boolean;
public
  constructor Create;
  destructor Destroy; override;
  procedure Enter; inline;
  procedure Leave; inline;
  property Locked: Boolean;
end;
//}}}

implementation

Function InttoStr;
begin
  Str(Value, Result);
end;

Function StrtoInt;
  Var
    Code: integer;
begin
  Val(Value, Result, Code);
end;

Function StrToIntDef(Value: String; Def: integer): integer;
  Var
    Code: integer;
begin
  Val(Value, Result, Code);
    If Code <> 0 then
      Result := Def;
end;

Function StrToFloat(S: String): Single;
  Var
    Code: Integer;
begin
    If Pos('.', S) <> 0 then begin
      //Insert(',', S, Pos('.', S));
      //Delete(S, Pos('.', S), 1);
    end;
  Val(S, Result, Code);
end;

Function FloatToStr(F: Single): String;
begin
  Str(F, Result);
    If Pos(',', Result) <> 0 then begin
      Insert('.', Result, Pos(',', Result));
      Delete(Result, Pos(',', Result), 1);
    end;
end;

Function HexDigitToInt(C: Char): Byte;
begin
  if C in ['A'..'F'] then
    Result := Ord(C) - Ord('A') + 10
  else if C in ['a'..'f'] then
    Result := Ord(C) - Ord('a') + 10
  else if C in ['0'..'9'] then
    Result := Ord(C) - Ord('0')
  else
    Result := 0;
end;

Function HexToInt(S: String): Integer;
begin
  Result := 0;
  while Length(S) > 0 do begin
    Result := Result*16 + HexDigitToInt(S[1]);
    Delete(S, 1, 1);
  end;
end;

const
   HexDigits: array[0..15] of char = '0123456789ABCDEF';

function IntToHex;
  var 
    i: integer;
begin
 SetLength(result, digits);
 for i := 0 to digits - 1 do
  begin
   result[digits - i] := HexDigits[value and 15];
   value := value shr 4;
  end ;
 while value <> 0 do begin
   result := HexDigits[value and 15] + result;
   value := value shr 4;
 end;
end ;

function CharArrToStr(const C : Array of Char) : String;
var I : Integer;
begin
  // convert the array of characters to a String
  I :=0;
  result :='';
  while C[i] <> #0 do
  begin
    result := result + C[I];
    Inc(I);
  end;
end;

Function FileExist;
  Var
    F: File;
begin
  FileMode := 64;
  AssignFile(F, Filename);
  {$I-}
  Reset(F);
  {$I+}
  Result := IOResult = 0;
    If Result then
      CloseFile(F);
end;

Procedure CreateFile;
  Var
    F: TextFile;
begin
    If FileExist(FileName) then
      Exit;
  Assign(F, FileName);
  {$I-}
  Rewrite(F);
  {$I+}
    If IOResult = 0 then
      Close(F);
end;

Procedure DeleteFile;
begin
    If not FileExist(Filename) then
      Exit;
  Windows.DeleteFile(PAnsiChar(Filename));
end;

Function GetTimer;
var
  T, F: LARGE_INTEGER;
begin
  QueryPerformanceFrequency(int64(F));
  QueryPerformanceCounter(int64(T));
  Result:=Trunc(1000*T.QuadPart/F.QuadPart);
end;

Function AnsiLowerCase(Const S: String): String;
  Var
    Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
    If Len > 0 then
      CharLowerBuff(Pointer(Result), Len);
end;

function ToStr(V: array of Const): string;
  Var
    I: Integer;
begin
  Result := '';
  for I := 0 to High(V) do
    case V[I].vType of 
      vtInteger: Result += IntToStr(V[I].vInteger);
      vtBoolean: Result += IntToStr(Ord(V[I].vBoolean));
      vtChar: Result += V[I].vChar;
      vtString: Result += V[I].vString^;
      vtPointer: Result += '@' + IntToStr(LongInt(V[I].vPointer));
      vtPChar: Result += V[I].vPChar;
      vtObject:
        begin
          Result += '<' + V[I].vObject.ClassName + '>';
        end;
      vtClass: Result += '<' + V[I].vClass.ClassName + '>';
      vtAnsiString: Result += AnsiString(V[I].vAnsiString);
    else
      Result += '?';
    end;
end;

Function GetBit(B: Byte; ID: Integer): Boolean;
begin
  Result := (B And (1 shl ID)) > 0;
end;

Function SetBit;
begin
    If Flag then
      Result := B Or (1 shl ID)
    else
      Result := B And Not (1 shl ID);
end;

// TIniFile//{{{
//
Class Function TIniFile.FindFieldInSection;
  Var
    I: integer;
begin
    With Section do begin
        For I := 0 to High(Fields) do
          With Fields[I] do
            If Name = Field then begin
              Result := I;
              Exit;
            end;
    end;
  Result := -1;
end;

Class Procedure TIniFile.SetFieldInSection;
  Var
    Index: integer;
begin
  Index := FindFieldInSection(Section, Field);
    If Index = -1 then
        With Section do begin
          SetLength(Fields, Length(Fields) + 1);
          Fields[High(Fields)].Name := Field;
          Index := High(Fields);
        end;
    With Section do
      Fields[Index].Value := Value;
end;

Class Function TIniFile.GetFieldInSection;
  Var
    Index: integer;
begin
  Index := FindFieldInSection(Section, Field);
    If Index = -1 then
      Result := '???'
    else
      With Section do
        Result := Fields[Index].Value;
end;

Function TIniFile.FindSection;
  Var
    I: integer;
begin
    For I := 0 to High(Sections) do
      If Sections[I].Name = Section then begin
        Result := I;
        Exit;
      end;
  Result := -1;
end;

Procedure TIniFile.AddSection;
begin
  SetLength(Sections, Length(Sections) + 1);
  Sections[High(Sections)].Name := Section;
  SetLength(Sections[High(Sections)].Fields, 0);
end;

Procedure TIniFile.Clear;
  Var
    I: integer;
begin
    For I := 0 to High(Sections) do
      With Sections[I] do
        SetLength(Fields, 0);
  SetLength(Sections, 0);
end;

Constructor TIniFile.Create;
begin
  Self.FileName := FileName;
  Update;
end;

Destructor TIniFile.Destroy;
begin
  Flush;
  inherited;
end;

Procedure TIniFile.Update;
  Var
    F: TextFile;
    S: String;
    Field, Value: String;
begin
  FLoaded := True;
    If not FileExist(FileName) then begin
      FLoaded := False;
      CreateFile(FileName);
    end;
  Clear;
  Assign(F, FileName);
  {$I-}
  Reset(F);
  {$I+}
    If IOResult <> 0 then begin
      FLoaded := False;
      Exit;
    end;
    While not Eof(F) do begin
      Readln(F, S);
        If Pos('//', S) <> 1 then
          If (Pos('[', S) > 0)and(Pos('[', S) < Pos(']', S)) then begin
            Delete(S, 1, Pos('[', S));
            Delete(S, Pos(']', S), Length(S) - Pos(']', S) + 1);
            AddSection(S);
          end else
          If Pos('=', S) <> 0 then begin
            Field := S;
            Delete(Field, Pos('=', Field), Length(Field) - Pos('=', Field) + 1);
            Value := S;
            Delete(Value, 1, Pos('=', Value));
              If Length(Sections) = 0 then
                AddSection('');
            SetFieldInSection(Sections[High(Sections)], Field, Value);
          end;
    end;
  Close(F);
end;

Procedure TIniFile.Flush;
  Var
    F: TextFile;
    I, J: integer;
begin
  Assign(F, Filename);
  {$I-}
  Rewrite(F);
  {$I+}
    For I := 0 to High(Sections) do begin
      With Sections[I] do begin
        Writeln(F, '[' + Name + ']');
          For J := 0 to High(Fields) do
            With Fields[J] do
              Writeln(F, Name + '=' + Value);
      end;
    end;
  Close(F);
end;

Function TIniFile.GetField;
  Var
    Index: integer;
begin
  Index := FindSection(Section);
    If Index = -1 then
      Result := '???'
    else
      Result := GetFieldInSection(Sections[Index], Field);
end;

Procedure TIniFile.SetField;
  Var
    Index: integer;
begin
  Index := FindSection(Section);
    If Index = -1 then begin
      AddSection(Section);
    end;
  SetFieldInSection(Sections[High(Sections)], Field, Value);
end;
//}}}
//
//  TTimer
//
Constructor TTimer.Create;
begin
  Int := Interval;
  Old := GetTimer;
end;

Procedure TTimer.SetInterval(Interval: Integer);
begin
  Int := Interval;
end;

Function TTimer.Pop;
begin
  Result := GetTimer > (Old + Int);
    If Result then
      Inc(Old, Int);
end;

Procedure TTimer.Reset;
begin
  Old := GetTimer;
end;

//
//  TData
//
Constructor TData.create(filename:string);
  Var 
    f : file;
    R: Integer;
begin
  Bytes := nil;
  assign(f,filename);
  {$I-}
  reset(f,1);
  {$I+}
  R := IOResult;
    If R <> 0 then begin
      WriteLn('TData.create: Not loaded: "', filename, 
              '", error: ', R); // TODO: Remove it.
      exit;
    end;
  len := filesize(f);
    If len = 0 then
      exit;
  SetLength(bytes, len);
  BlockRead( f , bytes[0] , len );
  Close    ( f );
  Pos := 0;
end;

//-----------------------------------------------------------------------------
Destructor TData.Destroy;
begin
  SetLength(bytes, 0);
end;

//-----------------------------------------------------------------------------
Function TData.isEmpty : boolean;
begin
  result := pos >= len;
end;

//-----------------------------------------------------------------------------
Procedure TData.getVar(p: pointer; size: integer);
  Var i: integer;
begin
    for i := 0 to size - 1 do
      PArrayOfBytes(p)^[i] := bytes[Abs(pos) + i];
  inc(pos, size);
end;

//-----------------------------------------------------------------------------
Function TData.GetByte : byte;
begin
  Result := 0;
    If pos < len then begin
      Result := Bytes[pos];
      Inc(Pos);
    end else
      Result := 0;
end;

//-----------------------------------------------------------------------------
Function TData.GetWord : word;
begin
  Result := 0;
    If pos < len - 1 then begin
      Result := word(getPtr^);
      Inc(Pos, SizeOf(word));
    end;
end;

//-----------------------------------------------------------------------------
Function TData.GetInteger: integer;
begin
  Result := 0;
    If pos < len - 3 then begin
      Result := integer(GetPtr^);
      Inc(Pos, SizeOf(integer))
    end
end;

//-----------------------------------------------------------------------------
Function TData.GetCardinal : cardinal;
begin
  Result := 0;
    If pos < len - 3 then begin
      result := cardinal( getPtr^ );
      inc( pos, sizeOf( cardinal ) );
    end;
end;

//-----------------------------------------------------------------------------
Function TData.GetFloat : single;
begin
  Result := 0;
    If Pos < Len - SizeOf(single) + 1 then begin
      Result := single(GetPtr^);
      Inc(Pos, SizeOf(single));
    end;
end;

//-----------------------------------------------------------------------------
Function TData.getString : string;
  Var len: byte;
begin
  Len := GetByte;
  SetLength(Result, Len);
  GetVar(@result[1], Len);
end;

//-----------------------------------------------------------------------------
Function TData.getPChar: string;
  Var
  c: char;
begin
  Result := '';
  c := chr(GetByte);
    while c <> #0 do begin
      Result := Result + c;
      c := chr(GetByte);
    end;
end;

//-----------------------------------------------------------------------------
Function TData.getPtr : pointer;
begin
    If Pos < Len then
      Result := @Bytes[pos]
    else
      Result := nil;
end;

//-----------------------------------------------------------------------------
Function TData.seekCur(delta: integer): integer;
begin
  Pos := Abs(Pos) + delta;
    If Pos > Len then
      Pos := Len;                          
  Result := Pos;
end;

//-----------------------------------------------------------------------------
Function TData.seekAbs(offs: integer): integer;
begin
  Pos := Offs;
    If Pos > Len then
      Pos := Len;
  Result := Pos;
end;

Function TData.Ready: Boolean;
begin
  Result := Bytes <> nil;
end;

procedure TData.Clear;
begin
  SetLength(Bytes, 0);
  len := 0;
end;

procedure TData.WriteToFile(FileName: string);
  var
    F: file of Byte;
begin
  Assign(F, FileName);
  {$I-}
  Rewrite(F);
  {$I+}
  if IOResult <> 0 then
    Exit;
  //SetLength(Bytes, Length(Bytes));
  BlockWrite(F, Bytes[0], Length(Bytes));
  Close(F);
end;

procedure TData.WriteVar(P: Pointer; Size: Integer);
begin
  SetLength(Bytes, Length(Bytes) + Size);
  Move(P^, Bytes[Length(Bytes) - Size], Size);
  len := Length(Bytes);
end;

procedure TData.WriteInt(I: Integer);
begin
  WriteVar(@I, SizeOf(Integer));
end;

procedure TData.WriteByte(B: Byte);
begin
  WriteVar(@B, SizeOf(Byte));
end;

procedure TData.WriteFloat(F: Float);
begin
  WriteVar(@F, SizeOf(Float));
end;

//
//  TTextData//{{{
//
Constructor TTextData.Create(FileName: String; Br: String);
  Var
    Data: TData;
    //C: Char;
    I: Integer;
begin
  Data := TData.Create(FileName);
  SetLength(FLines, 1);
  FLines[0] := '';
  I := 0;
    While Not Data.IsEmpty do begin
      FLines[I] += Char(Data.GetByte);
        If Pos(Br, FLines[I]) <> 0 then begin
          Delete(FLines[I], Pos(Br, FLines[I]), 
                    Length(FLines[I]) - Pos(Br, FLines[I]) + 1);
          SetLength(FLines, Length(FLines) + 1);
          Inc(I);
          FLines[I] := '';
        end;
    end;
    If FLines[High(FLines)] = '' then
      SetLength(FLines, Length(FLines)-1);
  FPos := 0;
  WriteLn('Data size: ', Data.Len);
  Data.Free;
  WriteLn('LinesCount: ', LinesCount);
end;

Procedure TTextData.SeekAbs(NewPos: Integer);
begin
  FPos := NewPos;
end;

Procedure TTextData.SeekCur(Delta: Integer);
begin
  FPos += Delta;
end;

Procedure TTextData.Rewind;
begin
  SeekAbs(0);
end;

Function TTextData.LinePos: Integer;
begin
  Result := FPos;
end;

Function TTextData.LinesCount: Integer;
begin
  Result := Length(FLines);
end;

Function TTextData.NextLine: String;
begin
  Result := GetLine(FPos);
  Inc(FPos);
end;

Function TTextData.IsEmpty: Boolean;
begin
  Result := FPos >= LinesCount;
end;

Function TTextData.GetLine(Index: Integer): String;
begin
    If (0 <= Index)And(Index < LinesCount) then
      Result := FLines[Index]
    else
      Result := '';
end;
//}}}

// TCriticalSection//{{{
//
constructor TCriticalSection.Create;
begin
  InitCriticalSection(FCS);
  FLocked := False;
end;

destructor TCriticalSection.Destroy;
begin
  DoneCriticalSection(FCS);
end;

procedure TCriticalSection.Enter;
begin
  EnterCriticalSection(FCS);
  FLocked := True;
end;

procedure TCriticalSection.Leave;
begin
  FLocked := False;
  LeaveCriticalSection(FCS);
end;
//}}}

end.
