unit ResImage;

interface

Uses
  DUtils,
  DDebug,
  DCore,

  ResCore;

Type
TImage = class(TResource)
private
  FWidth: Integer;
  FHeight: Integer;
  FBitsPerPixel: Integer;
  FTexels: Pointer;
public
  Procedure Init(Width, Height, BPP: Integer; P: Pointer);
  Property Width: Integer read FWidth;
  Property Height: Integer read FHeight;
  Property BitsPerPixel: Integer read FBitsPerPixel;
  Property Texels: Pointer read FTexels;
end;

Var
  ImgMan: TManager;

Function MakeRgba(Red, Green, Blue: Byte; Alpha: Byte = 255): Cardinal;

implementation

Procedure TImage.Init(Width, Height, BPP: Integer; P: Pointer);
begin
  FWidth := Width;
  FHeight := Height;
  FBitsPerPixel := BPP;
  FTexels := P;
end;

Function MakeRgba(Red, Green, Blue: Byte; Alpha: Byte = 255): Cardinal;
begin
  Result := Red + (Green shl 8) + (Blue shl 16) + (Alpha shl 24);
end;

initialization
  ImgMan := TManager.Create(Nil);
finalization
  ImgMan.Free;
end.
