uses
  DUtils,
  ResImage,
  ResBMP;

var
  I, J: Integer;

  Data: TData;
  Image: TImage;
  Loader: TBmpLoader;

  Header : packed record
    idLength: Byte;
    colormapType: Byte;
    imageType: Byte;
    colormapIndex: Word;
    colormapLength: Word;
    colormapEntrySize: Byte;
    xOrigin: Word;
    yOrigin: Word;
    width: Word;
    height: Word;
    pixelSize: Byte;
    imageDesc: Byte;
  end;


begin
  if ParamCount < 2 then begin
    Writeln('bmp2tga <input> <output>');
    Writeln('input must be bmp file');
    Exit;
  end;
  Loader := TBMPLoader.Create(nil);
  Data := TData.Create(ParamStr(1));
  Image := TImage(Loader.Load(ParamStr(1), Data));
  if Image = nil then begin
    Writeln('input must be bmp file');
  end else begin
    Data.Clear;
    FillChar(Header, SizeOf(Header), 0);
    Header.ImageType := 2;
    Header.PixelSize := 32;
    Header.Width := Image.Width;
    Header.Height := Image.Height;
    Header.ImageDesc := 0;
    Data.WriteVar(@Header, SizeOf(Header));
    if Image.BitsPerPixel = 3 then
      for J := Header.Height - 1 downto 0 do 
        for I := 0 to Header.Width - 1 do 
          with Data, Image do begin
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 2]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 1]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 0]);
            WriteByte(255);
          end
    else 
      for J := Header.Height - 1 downto 0 do 
        for I := 0 to Header.Width - 1 do 
          with Data, Image do begin
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*4 + 2]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*4 + 1]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*4 + 0]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*4 + 4]);
          end;
    Data.WriteToFile(ParamStr(2));
  end;
  Data.Free; 
  Loader.Free;
end.
