// D3DEngine.h: interface for the CD3DEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_D3DENGINE_H__5D139BAA_2F8C_4C0B_8B61_9D6105086045__INCLUDED_)
#define AFX_D3DENGINE_H__5D139BAA_2F8C_4C0B_8B61_9D6105086045__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "includes.h"
#include "XObject.h"
#include "Screen.h"
#include "Camera.h"
#include "Keyboard.h"
#include "Mouse.h"
#include "Fps.h"
#include "TxtBlock.h"
#include <vector>
//#include "AddMath.h"

#include "Add/d3dfont.h"
/////////////////#include "Add/d3dutil.h"

//#include <list>
//#include <iostream>

//typedef list<int> LISTINT;

// DEFINITION GLOBAL //
/*LPDIRECT3D9             g_pD3D           = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice     = NULL; // Our rendering device
D3DPRESENT_PARAMETERS d3dpp; 
D3DCAPS9 d3dCaps;*/


class CD3DEngine  
{
public:
	CD3DEngine();
	virtual ~CD3DEngine();

	D3DXMATRIXA16 matWorld;
	D3DXMATRIXA16 matView;


	CScreen Screen;

	CCamera Camera;

	CKeyboard Keyboard;

	CMouse Mouse;

	CFps Fps;
	double GM_SPEED;
	
	//Tlist_obj Lst;
	//std::vector <CXObject*> XObject;
	CXObject *XObject;
	//CXObject XObject[16];
	int NumXObjects;

	CTxtBlock *TxtBlock;
	int NumTxtBlocks;
	
	CD3DFont* TxtFont;
	CD3DFont* FontMenu;
	CD3DFont* FontMenuSm;

	D3DCOLOR BackGrColor;

	void ChangeFont(int n, TCHAR font_name[80], int font_size, int bi_flag);
	HRESULT Init( HWND hWnd );
	HRESULT InitFonts(int nm);
	void CleanUp();
	void StartDraw();
	void LightOn();
	void Render();
	void EndDraw();
	void SetBackGrColor(D3DCOLOR);
	HRESULT Resize( HWND hWnd );
	VOID SetupMatrices();
	void AddXObjects(int nm);
	//void AddXObject(char* xfilename);
	void AddTxtBlocks(int nm);

};

#endif // !defined(AFX_D3DENGINE_H__5D139BAA_2F8C_4C0B_8B61_9D6105086045__INCLUDED_)
