// Mouse.cpp: implementation of the CMouse class.
//
//////////////////////////////////////////////////////////////////////

#include "Mouse.h"

//#include "System.h"
//extern CSystem sys;
extern LPDIRECT3DDEVICE9       g_pd3dDevice   ; // Our rendering device engine.cpp
extern HWND hWnd; // winmain.cpp

struct D3DVERTEX
{
    D3DXVECTOR3 p;
    D3DXVECTOR3 n;
    FLOAT       tu, tv;

    static const DWORD FVF;
};
const DWORD D3DVERTEX::FVF = D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1;



struct INTERSECTION
{
    DWORD dwFace;                 // mesh face that was intersected
    FLOAT fBary1, fBary2;         // barycentric coords of intersection
    FLOAT fDist;                  // distance from ray origin to intersection
    FLOAT tu, tv;                 // texture coords of intersection
};



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMouse::CMouse()
{

}

CMouse::~CMouse()
{

}

void CMouse::PressButton(int button, int x, int y)
{
	// ** LEFT BUTTON ** //
	if (button == 1){
		left_button = TRUE;
	}
	if (button == 11){
		left_button = FALSE;
	}

	// ** RIGHT BUTTON ** //
	if (button == 2){
		right_button = TRUE;
	}
	if (button == 12){
		right_button = FALSE;
	}

	// ** 3th BUTTON ** //
	if (button == 3){
		middle_button = TRUE;
	}
	if (button == 13){
		middle_button = FALSE;
	}

}


void CMouse::SetPosition(POINT new_pos, int width, int height )
{
	position = new_pos;
	abs_position.x = (float)position.x / (float) width; //sys.setting.width;
	abs_position.y = (float)position.y / (float) height; //sys.setting.height;

}

void CMouse::SetPositionABS(CVector new_pos_abs, int width, int height)
{
	abs_position = new_pos_abs;
	position.x = abs_position.x * (float) width; //sys.setting.width;
	position.y = abs_position.y * (float) height; //sys.setting.height;
}

CVector CMouse::Pick3D(int sW, int sH, D3DXMATRIXA16 &matView)
{
	HRESULT hr;
	D3DXVECTOR3 vPickRayDir;
	D3DXVECTOR3 vPickRayOrig;
	CVector ret;

	// Get the pick ray from the mouse position
  /*  if( GetCapture() )
    {*/
        D3DXMATRIXA16 matProj;
        g_pd3dDevice->GetTransform( D3DTS_PROJECTION, &matProj );

        POINT ptCursor;
        GetCursorPos( &ptCursor );
        ScreenToClient( hWnd, &ptCursor );

        // Compute the vector of the pick ray in screen space
        D3DXVECTOR3 v;
        v.x =  ( ( ( 2.0f * ptCursor.x ) / sW) - 1 ) / matProj._11;
        v.y = -( ( ( 2.0f * ptCursor.y ) / sH) - 1 ) / matProj._22;
        v.z =  1.0f;

        // Get the inverse view matrix
        D3DXMATRIXA16 /*matView,*/ m;
        g_pd3dDevice->GetTransform( D3DTS_VIEW, &matView );
        D3DXMatrixInverse( &m, NULL, &matView );

        // Transform the screen space pick ray into 3D space
        vPickRayDir.x  = v.x*m._11 + v.y*m._21 + v.z*m._31;
        vPickRayDir.y  = v.x*m._12 + v.y*m._22 + v.z*m._32;
        vPickRayDir.z  = v.x*m._13 + v.y*m._23 + v.z*m._33;
        vPickRayOrig.x = m._41;
        vPickRayOrig.y = m._42;
        vPickRayOrig.z = m._43;

		

		/*vPick.x = vPickRayOrig.x;
		vPick.y = vPickRayOrig.y;
		vPick.z = vPickRayOrig.z;*/
    //}

		//!!//
		

		float correct_xy = -(vPickRayOrig.z + 500.0f)/1000.0f + 0.79f ;
		vPick.x = vPickRayOrig.x + (position.x-sW/2)*correct_xy;//(Engine.Screen.Width*vPickRayDir.x);
		vPick.y = vPickRayOrig.y - (position.y-sH/2)*correct_xy;//(Engine.Screen.Height*vPickRayDir.y);
		//vPick.z = 172;


			
		ret.x = vPick.x;
		ret.y = vPick.y;
		ret.z = vPick.z;

	return ret;
}

CVector CMouse::Pick3DMesh(int sW, int sH, D3DXMATRIXA16 &matView, LPD3DXBASEMESH pMesh)
{


	HRESULT hr;
	D3DXVECTOR3 vPickRayDir;
	D3DXVECTOR3 vPickRayOrig;
	CVector ret;

	// Get the pick ray from the mouse position
  /*  if( GetCapture() )
    {*/
        D3DXMATRIXA16 matProj;
        g_pd3dDevice->GetTransform( D3DTS_PROJECTION, &matProj );

        POINT ptCursor;
        GetCursorPos( &ptCursor );
        ScreenToClient( hWnd, &ptCursor );

        // Compute the vector of the pick ray in screen space
        D3DXVECTOR3 v;
        v.x =  ( ( ( 2.0f * ptCursor.x ) / sW) - 1 ) / matProj._11;
        v.y = -( ( ( 2.0f * ptCursor.y ) / sH) - 1 ) / matProj._22;
        v.z =  1.0f;

        // Get the inverse view matrix
        D3DXMATRIXA16 /*matView,*/ m;
        g_pd3dDevice->GetTransform( D3DTS_VIEW, &matView );
        D3DXMatrixInverse( &m, NULL, &matView );

        // Transform the screen space pick ray into 3D space
        vPickRayDir.x  = v.x*m._11 + v.y*m._21 + v.z*m._31;
        vPickRayDir.y  = v.x*m._12 + v.y*m._22 + v.z*m._32;
        vPickRayDir.z  = v.x*m._13 + v.y*m._23 + v.z*m._33;
        vPickRayOrig.x = m._41;
        vPickRayOrig.y = m._42;
        vPickRayOrig.z = m._43;


		///! Mesh Intersect //
		//LPD3DXBASEMESH          pMesh = Mesh->GetLocalMesh();
        LPDIRECT3DVERTEXBUFFER9 pVB;
        LPDIRECT3DINDEXBUFFER9  pIB;

        pMesh->GetVertexBuffer( &pVB );
        pMesh->GetIndexBuffer( &pIB );

        WORD*      pIndices;
        D3DVERTEX*    pVertices;

        pIB->Lock( 0, 0, (void**)&pIndices, 0 );
        pVB->Lock( 0, 0, (void**)&pVertices, 0 );

		///!
		// Collect only the closest intersection
        BOOL bHit;
        DWORD dwFace;
        FLOAT fBary1, fBary2, fDist;
        D3DXIntersect(pMesh, &vPickRayOrig, &vPickRayDir, &bHit, &dwFace, &fBary1, &fBary2, &fDist, 
              NULL, NULL);
		pVB->Unlock();
		pIB->Unlock();

		pVB->Release();
		pIB->Release();

        if( bHit ) {
                    /*m_dwNumIntersections = 1;
                    m_IntersectionArray[0].dwFace = dwFace;
                    m_IntersectionArray[0].fBary1 = fBary1;
                    m_IntersectionArray[0].fBary2 = fBary2;
                    m_IntersectionArray[0].fDist = fDist;*/
			
			vPickMesh.x=vPickRayDir.x*fDist;
			vPickMesh.y=vPickRayDir.y*fDist;
			vPickMesh.z=vPickRayDir.z*fDist;

        } else return CVector(-255,-255,-255);



		///!


		/*float correct_xy = -(vPickRayOrig.z + 500.0f)/1000.0f + 0.79f ;
		vPick.x = vPickRayOrig.x + (position.x-sW/2)*correct_xy;//(Engine.Screen.Width*vPickRayDir.x);
		vPick.y = vPickRayOrig.y - (position.y-sH/2)*correct_xy;//(Engine.Screen.Height*vPickRayDir.y);
		//vPick.z = 172;
		
		ret.x = vPick.x;
		ret.y = vPick.y;
		ret.z = vPick.z;*/

		

	return vPickMesh;
}