// XObject.h: interface for the CXObject class.
//
//////////////////////////////////////////////////////////////////////

#include "includes.h"



#define PL_TEX_NORMAL 0x00000000L
#define PL_TEX_SPHERE 0x00040000L
#define PL_TEX_MIRROR 0x00030000L
#define PL_TEX_SCREEN 0x00010000L
#define PL_TEX_SCREEN2 0x00020000L

//#define PL_MTEX_MULTY 

#define	PL_D3DTOP_DISABLE 1
#define	PL_D3DTOP_SELECTARG1 2
#define	PL_D3DTOP_SELECTARG2 3
#define	PL_D3DTOP_MODULATE 4
#define	PL_D3DTOP_MODULATE2X 5
#define	PL_D3DTOP_MODULATE4X 6
#define	PL_D3DTOP_ADD 7
#define	PL_D3DTOP_ADDSIGNED 8
#define	PL_D3DTOP_ADDSIGNED2X 9
#define	PL_D3DTOP_SUBTRACT 10
#define	PL_D3DTOP_ADDSMOOTH 11
#define	PL_D3DTOP_BLENDDIFFUSEALPHA 12
#define	PL_D3DTOP_BLENDTEXTUREALPHA 13
#define	PL_D3DTOP_BLENDFACTORALPHA 14
#define	PL_D3DTOP_BLENDTEXTUREALPHAPM 15
#define	PL_D3DTOP_BLENDCURRENTALPHA 16
#define	PL_D3DTOP_PREMODULATE 17
#define	PL_D3DTOP_MODULATEALPHA_ADDCOLOR 18
#define	PL_D3DTOP_MODULATECOLOR_ADDALPHA 19
#define	PL_D3DTOP_MODULATEINVALPHA_ADDCOLOR 20
#define	PL_D3DTOP_MODULATEINVCOLOR_ADDALPHA 21
#define	PL_D3DTOP_BUMPENVMAP 22
#define	PL_D3DTOP_BUMPENVMAPLUMINANCE 23
#define	PL_D3DTOP_DOTPRODUCT3 24
#define	PL_D3DTOP_MULTIPLYADD 25
#define	PL_D3DTOP_LERP 26
#define	PL_D3DTOP_FORCE_DWORD 0x7fffffff



#if !defined(AFX_XOBJECT_H__65CD8A8D_A02E_495B_9A3D_A54B163465C4__INCLUDED_)
#define AFX_XOBJECT_H__65CD8A8D_A02E_495B_9A3D_A54B163465C4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CXObject  
{
public:
	CXObject();
	virtual ~CXObject();
	
	CVector Position;
	CVector Angle; //AddAngle;
	CVector Scale;
	char Path[128];
	
	D3DXMATRIXA16 extMatrix;


	LPD3DXMESH          Mesh         ; // Our mesh object in sysmem
	//ID3DXMESH          Mesh         ;
	D3DMATERIAL9*           MeshMaterials ; // Materials for our mesh
	LPDIRECT3DTEXTURE9*     MeshTextures  ; // Textures for our mesh
	DWORD                   NumMaterials ;   // Number of mesh materials
	
	LPDIRECT3DTEXTURE9 SecondTexture;

	LPDIRECT3DVERTEXBUFFER9 g_pVB;

	bool bMultiTexture;

	bool Visible;

	CVector TextureScale[8];
	int TextureMode[8];
	int TextureAdd[8];

	D3DXVECTOR3 BBox_Min, BBox_Max;

	HRESULT Load(char * filename);

	void SetPosition(CVector new_pos);
	void SetOrientation(CVector new_angle);
	void SetScale(CVector new_scale);
	
	void Draw(int mode); // DW_SOLID, DW_WIRE, DW_... //
	void DrawBBox();
	
	void LoadSecondTexture(char* filename);
	void SetTextureMode(int N_tex, int tmode, int tadd);
	void SetTextureScale(int N_tex, CVector new_scale);

	void CalcBBox();

	void CleanUp();

};

#endif // !defined(AFX_XOBJECT_H__65CD8A8D_A02E_495B_9A3D_A54B163465C4__INCLUDED_)
