//
// WINMAIN.CPP //
//

#include <windows.h>
//#include "resource.h"
#include "PLD3DEngine\D3DEngine.h"
#include "Game.h"

//#include "resource.h"

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
CGame Game;
extern CD3DEngine Engine;
HWND hWnd;
// DEFINITION GLOBAL //
/*LPDIRECT3D9             g_pD3D           = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice     = NULL; // Our rendering device
D3DPRESENT_PARAMETERS d3dpp; 
D3DCAPS9 d3dCaps;*/

//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_PAINT: 
		 break;
		case WM_DESTROY:
			{
            //Engine.CleanUp();
            PostQuitMessage( 0 );
            return 0;
			}break;
		case WM_SIZE:
			//Engine.Resize(hWnd);
			//Engine.Render();
            ValidateRect( hWnd, NULL );
			return 0;

		//       . .
		/*case WM_PAINT:
            Engine.Render();
            ValidateRect( hWnd, NULL );
            return 0;
*/

		//      
		case WM_KEYDOWN:
			 Engine.Keyboard.Key[wParam] = TRUE;
			 //Game.PressKey();
			 break;

		case WM_KEYUP:
			 Engine.Keyboard.Key[wParam] = FALSE;
			 //Game.PressKey();
			 break;

		
		case WM_LBUTTONDOWN:
			//GetWindowRect(hWnd, &rect);
			Engine.Mouse.PressButton(1, LOWORD(lParam), HIWORD(lParam));
			return 0;
		
		case WM_LBUTTONUP:
			Engine.Mouse.PressButton(11, LOWORD(lParam), HIWORD(lParam));
			return 0;

		case WM_RBUTTONDOWN:
			Engine.Mouse.PressButton(2, LOWORD(lParam), HIWORD(lParam));
			return 0;

		case WM_RBUTTONUP:
			Engine.Mouse.PressButton(12, LOWORD(lParam), HIWORD(lParam));
			return 0;
		
		case WM_MBUTTONDOWN:
			Engine.Mouse.PressButton(3, LOWORD(lParam), HIWORD(lParam));
			return 0;

		case WM_MBUTTONUP:
			Engine.Mouse.PressButton(13, LOWORD(lParam), HIWORD(lParam));
			return 0;

		case WM_MOUSEMOVE:
			POINT p;
			p.x = LOWORD(lParam);
			p.y = HIWORD(lParam);
		
			Engine.Mouse.SetPosition(p, Engine.Screen.Width, Engine.Screen.Height);
		return 0;


		
	}

	return DefWindowProc( hWnd, msg, wParam, lParam );
}






//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
		
	
	// Register the window class
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), /*LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON1))*/NULL,  LoadCursor( NULL, IDC_ARROW ), NULL, NULL,
                      "PlasticD3D", NULL };
//	wc.hbrBackground	= (HBRUSH)GetStockObject(GRAY_BRUSH);
	//wc.hIcon			=  LoadIcon( hInst, MAKEINTRESOURCE("IDI_ICON1.ICO"));

    RegisterClassEx( &wc );

    // Create the application's window
    hWnd = CreateWindow( "PlasticD3D", "Plastic D3D K48 BoardGM", 
								//WS_POPUP | WS_SYSMENU, 0, 0, 640, 480,
                              //WS_OVERLAPPEDWINDOW, 100, 100, 400, 360,
							  WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX, 0, 0, 
								//600,600,			
							  Engine.Screen.Width, Engine.Screen.Height,
							  NULL, NULL, wc.hInstance, NULL );
                              //GetDesktopWindow(), NULL, wc.hInstance, NULL );

    // Initialize Direct3D
    if( SUCCEEDED( Engine.Init( hWnd ) ) )//InitD3D( hWnd ) ) )
    { 
        // Create the scene geometry
		Game.Init();
//        if( SUCCEEDED( InitGeometry() ) )
//        {
            // Show the window
            ShowWindow( hWnd, SW_SHOWDEFAULT );
            UpdateWindow( hWnd );

            // Enter the message loop
            MSG msg; 
            ZeroMemory( &msg, sizeof(msg) );
            while( msg.message!=WM_QUIT )
            {
                if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
                {
                    TranslateMessage( &msg );
                    DispatchMessage( &msg );
                }
				else{
					
                    Game.Loop();
					//Engine.Render();
					
				}
	        }
    }
	
	/*while(GetMessage(&msg,NULL,0,0))
 	 { 
		 TranslateMessage(&msg);
		 DispatchMessage(&msg);
	 } 	return(msg.wParam);*/
	//}
    UnregisterClass( "PlasticD3D", wc.hInstance );
    return 0;



}