#ifndef _BALL_H_
#define _BALL_H_

#include<core.h>
#include<hge.h>
#include <Box2D.h>

class CGameObject {
public:
	CGameObject(CCore *engine, HGE *Hge, b2World *MyWorld);
	~CGameObject(void);

	virtual bool Init(void) { return true; };
	virtual void Update(float delta) {};
	virtual void Render(void) {};

	//virtual int OnDead(void) { return 0; }; // returned Money
	virtual bool Collide(CGameObject *obj) { return false; };

	float x,y;
	float angle;
	float radius;
	bool life;
	int type;
	float Timer;
protected:
	CCore *Engine;
	HGE *hge;
	b2World *World;
};

class CPall : public CGameObject {
public:
	CPall(CCore *engine, HGE *Hge, b2World *world);
	~CPall(void);

	hgeSprite			*sprBody;
	hgeSprite*			spt;
	hgeFont*			fnt;
	hgeParticleSystem	*par1[8],*par2[8];

	HTEXTURE			tex,texBody;
	HEFFECT				sndSelect,sndWinner;

	bool Brosok;

	float speed, friction;
	bool isGameOver;
	bool flagTeam0Lose,flagTeam1Lose;
	
	b2Shape *shapes1[8],*shapes2[8];
	b2Shape *shapeIndicator;
	b2Shape *shapeField;
	b2Body *bodyIndicator,*bodyField;
	b2Body *bodys1[8],*bodys2[8];
	b2Body *SetBody;
	int CurrentTeam;
	int team[5];
	float lastMouseX,lastMouseY;
	bool Init(void);
	void Update(float delta);
	void Render(void);
protected:
	float Timer;
};

#endif