unit YY_board;

interface
uses
  Omega, LexUtils, YY_materials, GSound;

type
  TKletka = record
    Rast, MTextR,
    T, S, A, AA, ALF : byte;
    drop, act : boolean;
    X, Y, Expl: single;
    MTextX, MTextY : Word;
    MText : String;
    Clr : integer;

    ChColor : byte;
  end;
  
  TPlayer = record
    X, Y : word;
    MD : boolean;
    IP : string;
  end;

procedure Init;
procedure Draw;
function  Work : boolean;

var
  KletkaHW : single;
  Kletka: array[0..9, 0..9] of TKletka;
  KletkaColor: array[0..9, 0..9] of byte;
  bb : array[1..2,1..6] of byte;
  BSSz : array[1..2,1..6] of word;
  BSExpl : array[1..2,1..6] of single;
  BSRast : array[1..2,1..6] of byte;

  CordTrY, CordTrX, NRTextX, KolM,
  KlH, KlW, SDX, SDY, AllKolM : word;

  NRTextA : byte;

  GFB1S, GFB2S : byte;
  MakeCH : boolean = false;
implementation
uses
  YY_main, YY_game;

procedure addKlT(IX : byte);
begin
  Kletka[IX,0].T:=random(6)+1;
  Kletka[IX,0].ChColor:=KletkaColor[IX,1];
end;

procedure Init;
var
  IX, IY : byte;
begin
  for IX:=1 to 8 do
    begin
      for IY:=0 to 8 do
      with Kletka[IX, IY] do
        begin
          //drop:=false;
          T:=0;
          S:=1;
          ALF:=255;
          X:=SDX+(IX-1)*KlH;
          act:= false;
        end;
      addKlT(IX);
      Kletka[IX,0].A:=random(16)+1;
    end;
end;

procedure Draw;
var
  IX, IY, Spr : byte;
  Rst : word;
begin

  for IX:=1 to 8 do
  for IY:=1 to 8 do
  with Kletka[ IX, IY] do
   ASprite_Draw( TBK, SDX+(IX-1)*KlH, SDY+(IY-1)*KlH, KlH, KlH, KletkaColor[ IX, IY], 220);

  for IX:=1 to 8 do
  for IY:=1 to 8 do
  with Kletka[IX,IY] do
  begin
      if (drop) then S:=2
      else
      if (A=1) or (A=16) then S:=1;
      if Act then S:=2;
      if T>0 then
      ASprite_Draw(TCh[ChColor], X+KlW, Y, KlH/2, KlH-2, T, ALF);
      if Expl>0 then
      begin
          FX_SetColorMix(Clr);
          ASprite_Draw(TExpl, X-10, Y-10, KlH+20, KlH+20, round(Expl), 170, 0, FX_DEFAULT or FX_COLORMIX);
      end;
      if MTextR>10 then
      Text_Draw(FontA1, MTextX, MTextY, PChar(MTexT), 1, 0, MTextR, Clr);
  end;
end;


function GlowOF(Y : byte) : boolean;
var
  I : integer;
begin
  for I:=1 to 6 do
  if (I<>Y) and (bb[GPL][I]>0) then bb[GPL][I]:=1;
  result:=false;

  if bb[GPL][Y]>0 then
   begin
    inc(bb[GPL][Y]);
    BSSz[GPL][Y]:=KlH*2;
    if  bb[GPL][Y]>2 then
      begin
       PlaySound(S_Trea);
       BSExpl[GPL][Y]:=1;
       BSSz[GPL][Y]:=0;
       bb[GPL][Y]:=1;
       result:=true;
      end
    else
    PlaySound(S_flash[Y])
   end;
end;

Procedure DelN(TS : byte);
begin
 if GlowOF(6) then
end;

Function Del3 : boolean;

Procedure DelK(IX, IY : byte);
begin
  Kletka[IX, IY].drop:=true;
  if Kletka[IX, IY].ALF>254 then
    begin
      Kletka[IX, IY].ALF:=250;
      inc(AllKolM);
    end;
end;

var
  IX, IY, SY, TS, B, IB : byte;
begin
  result:=false;
  for IX:=1 to 8 do
    begin
      SY:=0;
      TS:=0;
      for IY:=1 to 7 do
      if Kletka[IX, IY].T<>0 then
        begin
          if (Kletka[IX, IY].T<>TS) then
            begin
              SY:=1;
              TS:=Kletka[IX, IY].T;
              B:=IY;
            end
           else
            begin
              inc(SY);
              if (SY>2) then
                begin
                  //  Y
                  if Kletka[IX, B].ALF>250 then
                    begin
                      DelN(TS);
                      if Kletka[IX, B].T<>7 then
                      PlaySound(S_exp[IY])
                      else
                      PlaySound(S_bum);
                    end;
                  for IB:=B to IY do
                  DelK(IX, IB);
                  result:=true;
                  KolM:=SY;
                  
                end;
            end;
        end
        else
        TS:=0;
    end;
  for IY:=1 to 7 do
    begin
      SY:=0;
      TS:=0;
      for IX:=1 to 8 do
      if Kletka[IX, IY].T<>0 then
        begin
          if (Kletka[IX, IY].T<>TS) then
            begin
              SY:=1;
              TS:=Kletka[IX, IY].T;
              B:=IX;
            end
           else
            begin
              inc(SY);
              if (SY>2) then
                begin
                  //  X
                  if Kletka[B, IY].ALF>250 then
                    begin
                      DelN(TS);
                      if Kletka[B, IY].T<>7 then
                      PlaySound(S_expY[IY])
                      else
                      PlaySound(S_bum);
                    end;
                  for IB:=B to IX do
                  DelK(IB, IY);
                  result:=true;
                  KolM:=SY;
                end;
            end;
        end
        else
        TS:=0;
    end;
end;

Function PoleProc: boolean;
var
  IX, IY : byte;
begin
  result:=true;
  for IX:=1 to 8 do
  for IY:=1 to 8 do
  with Kletka[IX,IY] do
   begin
    if (Kletka[IX,IY].Expl>0) and (Kletka[IX,IY].Expl<16) then
    Kletka[IX,IY].Expl:=Kletka[IX,IY].Expl+0.5
    else Kletka[IX,IY].Expl:=0;

    if Kletka[IX,IY].MTextR>10 then
    begin
      Kletka[IX,IY].MTextR:=Kletka[IX,IY].MTextR-3;
      Kletka[IX,IY].MTextY:=Kletka[IX,IY].MTextY-1;
    end;

    if drop then
    if  (X=(SDX+(IX-1)*KlH)) and (Y=(SDY+(IY-1)*KlH)) then drop:=false
    else
      begin
        result:=false;
        if Y<(SDY+(IY-1)*KlH) then app(Y,5);
        if X<(SDX+(IX-1)*KlH) then app(X,5);
        if Y>(SDY+(IY-1)*KlH) then app(Y,-5);
        if X>(SDX+(IX-1)*KlH) then app(X,-5);
      end
    else
      if (Kletka[IX,IY].T=0) and (not Kletka[IX,IY-1].drop) then
        begin
          result:=false;
          drop:=true;
          T:=Kletka[IX,IY-1].T;
          ChColor:= Kletka[IX,IY-1].ChColor;
          Kletka[IX,IY-1].T:=0;
          Y:=SDY+(IY-2)*KlH;
          X:=SDX+(IX-1)*KlH;
          addKlT(IX);
          Kletka[IX,0].A:=random(16)+1;
          A:=Kletka[IX,IY-1].A;
        end;
      inc(AA);
      if AA>1 then
        begin
          AA:=0;
          inc(A);
        end;
      IF A>32 then A:=1;

      if ALF<255 then
       begin
        if ALF<220 then
        dec(ALF,5)
        else
        dec(ALF,1);
        if ALF=220 then
         begin
          Points[GameSt]:= Points[GameSt] +7-Kletka[IX, IY].T;
          Kletka[IX, IY].Expl:=1;
          Kletka[IX, IY].Clr:=SetExplColor(Kletka[IX, IY].T);
          Kletka[IX, IY].MTextY:=round(Kletka[IX, IY].Y+Klh/2);
          Kletka[IX, IY].MTextX:=round(Kletka[IX, IY].X+Klh/2)-12;
          Kletka[IX, IY].MTextR:=255;
          if Kletka[IX, IY].T<7 then
          Kletka[IX, IY].MText:='+ '+U_Inttostr(7-Kletka[IX, IY].T)
          else
          Kletka[IX, IY].MText:='@';
         end;
        if ALF<30 then
          begin
            drop:=false;
            T:=0;
            S:=1;
            ALF:=255;
            X:=(IX+1)*KlH;
            act:= false;
          end;
      end;

//////////////

    end;



  if NRTextA>0 then Dec(NRTextA);

  for IX:=1 to 6 do
    begin
      if BsSz[GPL][IX]>0 then
        begin
          BsSz[GPL][IX]:=BsSz[GPL][IX]-10;
          if BsRast[GPL][IX]<170 then inc(BsRast[GPL][IX]);
        end;
      if (BsExpl[GPL][IX]>0) and (BsExpl[GPL][IX]<17) then BsExpl[GPL][IX]:=BsExpl[GPL][IX]+0.5
      else BsExpl[GPL][IX]:=0;
    end;

end;


function Work : boolean;
begin
  result:=FALSE;
  if PoleProc then
  if not Del3 then
    begin
      result:=TRUE;
      MakeCH:=false;

    end
  else
  if MakeCH then
  begin
    MakeCH:=false;
  end;
end;

end.
