unit YY_game;

interface
uses
  Omega, YY_Materials, LexUtils, YY_board, YY_AI, GSound;

procedure Init;
procedure Draw;
procedure Work;
function ChangeKM(X, Y : integer) : boolean;

var
  GameSt : byte=1;
  Points : array[1..3] of word;
  MkX, MkY, MX, MY, MSD
  : word;

  UseAI : boolean = true;

  Win  : boolean = false;


implementation
uses
  YY_main;

procedure Init;
var
  IX, IY, I : integer;
begin
  KlH:=round(WinH / 82)*10;
  KlW:=KlH div 4;
  SDX:=(WinW div 2)-4*KlH;
  SDY:=(WinH div 2)-4*KlH;

  for IX:=1 to 8 do
  for IY:=1 to 8 do
  if (IX+IY) mod 2 = 0  then KletkaColor[IX, IY]:=2
                        else KletkaColor[IX, IY]:=1;

  // Start
  YY_board.Init;
  GameSt:=1;


end;

procedure Draw;
begin
  YY_board.Draw;
  if Kletka[MkX, MkY].act then
  case GameSt of
  1 : SSprite_Draw( Tgreen, SDX+(MkX-1)*KlH, SDY+(MkY-1)*KlH, KlH, KlH, 220);
  3 : SSprite_Draw( Tred, SDX+(MkX-1)*KlH, SDY+(MkY-1)*KlH, KlH, KlH, 220);
  end;

  if UseAI then
  Text_Draw( FontA1, 10, WinH-50,  'AI ', 1, 0, 255, 0 );

  Case GameSt of
    1 :  Text_Draw( FontA1, 40, 1,  '  1', 1, 0, 255, 0 );
    2 :  Text_Draw( FontA1, (WinW - Text_GetWidth( FontA1, '', 1, 0 )) / 2, 1, '', 1, 0, 255, 0 );
    3 :  Text_Draw( FontA1, (WinW - Text_GetWidth( FontA1, '  2', 1, 0 )) - 20, 1, '  2', 1, 0, 255, 0 );
    4 :  Text_Draw( FontA1, (WinW - Text_GetWidth( FontA1, '', 1, 0 )) / 2, 1, '', 1, 0, 255, 0 );
  end;
  Text_Draw( FontA1, 10, 50,  ' 1:', 1, 0, 255, $FFFFFF );
  Text_Draw( FontA1, 50, 80,  PChar(Int2S(points[1])), 1, 0, 255, $FFFFFF );
  Text_Draw( FontA1, (WinW - Text_GetWidth( FontA1, ' 2:', 1, 0 )) - 20, 50, ' 2:', 1, 0, 255, 0 );
  Text_Draw( FontA1, (WinW - Text_GetWidth( FontA1, PChar(Int2S(points[3])), 1, 0 )) - 50, 80, PChar(Int2S(points[3])), 1, 0, 255, 0 );

end;

function ChangeKM(X, Y : integer) : boolean;
var
  FKK : TKletka;
begin
  If (X=MkX) and (Y=MkY) then
  MSD:=1
  else
  If (abs(X-MkX)<>abs(Y-MkY))
  and   ((abs(X-MkX)=1) or (abs(X-MkX)=0))
  and  ((abs(Y-MkY)=1) or (abs(Y-MkY)=0))
  then
    begin
      Kletka[X, Y].act:=false;
      Kletka[MkX, MkY].act:=false;
      Kletka[X, Y].drop:=true;
      Kletka[MkX, MkY].drop:=true;
      FKK:=Kletka[X,Y];
      Kletka[X, Y]:=Kletka[MkX, MkY];
      Kletka[MkX, MkY]:=FKK;
      MSD:=0;
      MakeCH:=true;
      result:=true;
      PlaySound(S_bell);
    end
  else
    begin
      MSD:=1;
      Kletka[MkX, MkY].act:=false;
      Kletka[X, Y].act:=true;
      MkX:=X;
      MkY:=Y;
    end;
end;

function Control : boolean;

function KlC : byte;
begin
 if GameSt=3 then result:=2
 else
 result:=1;
end;

begin
  result:=false;
  if MouseClick then
  if  (Mouse_X > SDX )
  and (Mouse_X < 8*KlH + SDX )
  and (Mouse_Y > SDY )
  and (Mouse_Y  < SDY + 8*KLH)
  then
    begin
      inc(MSD);
      MX:=(Mouse_X-SDX) div KlH +1;
      MY:=(Mouse_Y-SDY) div KlH +1;
      case MSD of
       1 : if Kletka[MX, MY].ChColor=KlC then
           begin
             MkX:=Mx;
             MkY:=My;
             Kletka[MkX, MkY].act:=true;
           end
           else
           begin
             MSD:=0;
           end;

       2 : begin
              result:=ChangeKM(Mx, My);
           end;
       else
       MSD:=0;
      end;
    end;
end;

procedure Work;
var
  d : boolean;
begin
  if Omega.Key_Press(k_ctrl) then UseAI:=not UseAI;


  d:=YY_board.Work;

  Case GameSt of
  1 :  if Control then GameSt:=2;
  2 :  if d then GameSt:=3;
  3 :  if UseAi then
       begin
       if YY_AI.Work then GameSt:=4;
       end
       else
       if Control then GameSt:=4;
  4 :  if d then GameSt:=1;
  end;
end;


end.
