{$MODE DELPHI}
program My_Game;
uses ZglHeader,ogg,windows,
 Messages, SysUtils, Variants, Classes;
//*********************************************************************
//*********************************************************************
//*********************************************************************
type TGame=record
score,level:LongInt;
end;
type TLevel=record
count_mines:LongInt;
background:ZGLPTexture;
map,npcmap:array[-1..16,-1..16] of LongInt;
queue:array[1..16*16+5] of LongInt;
npcway:array[0..32] of LongInt;
visible:array[-1..16,-1..16] of boolean;
end;
type TPlayer=record
x,y,points,doing,last_move:LongInt;
texture:ZglPTexture;
end;
type TExplo=record
frame,x,y,mult:LongInt;
end;
var game:TGame;
level:TLevel;
res:LongInt;
pause:LongInt;
player,npc:TPlayer;
now_play:LongInt;
scene:string;
explo:array[1..25] of Texplo;
background,one,two,act_mine,deact_mine,goal_texture,explo_texture,
null,none,four,three,background_menu,pb_button,pp_button,
exit_button,c_win,p1_win,p2_win,lamp_on,lamp_off:ZGLPtexture;
goal_x,goal_y:LongInt;
music:TOGG;
need_enter:boolean;
//***************************************
len_hod,goodtest_time,badtest_time,deactivation_time,activation_time,move_time,type_game:LongInt;
//*****************************************
//*********************************************************************
//*********************************************************************
//*********************************************************************
const TimerTick=25;
otstyp=16*5;
wBlock=(1024-2*otstyp) div 16;
HBlock=(768-2*otstyp) div 16;

//*********************************************************************
//*********************************************************************
//*********************************************************************

//////////////////////////////////

procedure LoadLevel(t:LongInt);forward;

procedure Win(v:LongInt);
begin
  if (v=1)and(type_game=1) then
  inc(game.level);
  if (game.level>5)or(game.level=10)or(type_game=2)or(v=2) then
  begin
  scene:='menu';
  if v=1 then background_menu:=p1_win
  else
    if type_game=1 then background_menu:=c_win
    else background_menu:=p2_win;
    need_enter:=true;
  end
  else LoadLevel(type_game);
end;


procedure New_Game(t:LongInt);
begin
  music.play(true);
  game.score:=0;
  game.level:=1;
  if t=2 then game.level:=0;
  LoadLevel(t);
  scene:='game';
end;

procedure Process_Menu;
var x,y:LongInt;
begin
  if not need_enter then
  begin
    x:=mouse_x;
    y:=mouse_y;
    if key_down(k_escape) then halt;
    if mouse_down(M_BLEFT) then
    if (x<=500) then
      begin
        if (y>=250)and(y<400) then New_Game(1);
        if (y>=400)and(y<550) then New_Game(2);
        if (y>=550)and(y<700) then halt;
      end;
  end
  else if key_up(k_enter) then begin need_enter:=false;
   background_menu:=Tex_LoadFromFIle('./pictures\menu.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  end;
  mouse_clearstate;
  key_clearstate;
end;

//////////////////////////////


procedure Update_Map;
var i,j:LongInt;
begin
  for i:=0 to 15 do
    for j:=0 to 15 do
      if level.npcmap[i,j]<>10 then
      level.npcmap[i,j]:=
    level.npcmap[i-1,j] div 10+level.npcmap[i+1,j] div 10+
    level.npcmap[i,j-1] div 10+level.npcmap[i,j+1] div 10+
    level.npcmap[i+1,j+1] div 10+level.npcmap[i-1,j-1] div 10+
    level.npcmap[i-1,j+1] div 10+level.npcmap[i+1,j-1] div 10;
end;

procedure Explo_process;
var i:LongInt;
begin
  for i:=1 to 25 do
    if explo[i].frame<=8 then
     inc(explo[i].frame);
end;

procedure Create_Explo(x,y,mult:LongInt);
var i:LongInt;
begin
  for i:=1 to 25 do
    if explo[i].frame>8 then
    begin
     explo[i].frame:=0;
     explo[i].x:=x;
     explo[i].y:=y;
     explo[i].mult:=mult;
     exit;
    end;
end;

procedure TestPlayerPosition(var player:TPlayer);
var x,y:LongInt;
begin
  x:=(player.x-otstyp) div wblock;
  y:=(player.y-otstyp) div hblock;
  level.visible[x,y]:=true;
  level.visible[x+1,y]:=true;
  level.visible[x,y+1]:=true;
  level.visible[x+1,y+1]:=true;
  if (level.map[x,y]=10)or(level.map[x+1,y]=10)or(level.map[x,y+1]=10)or(level.map[x+1,y+1]=10) then
  begin
     dec(player.points,activation_time);
     Create_Explo(player.x,player.y,2);
     if level.map[x,y]=10 then
       level.map[x,y]:=12;

     if level.map[x+1,y]=10 then
       level.map[x+1,y]:=12;

     if level.map[x+1,y+1]=10 then
       level.map[x+1,y+1]:=12;

     if level.map[x,y+1]=10 then
       level.map[x,y+1]:=12;

   level.npcmap[x,y]:=0;level.npcmap[x+1,y]:=0;level.npcmap[x,y+1]:=0;
   level.npcmap[x+1,y+1]:=0;
   Update_map;
  end;
end;



procedure Process_NPC;
var i,j,x:LongInt;

procedure Clear_Around(x,y:LongInt);
var vx,vy,i,j:LongInt;
begin
    for i:=-1 to 1 do
    for j:=-1 to 1 do
      if (j<>0)or(i<>0) then
        if (level.map[i+x,j+y]=10) then
        begin
          vx:=i+x;
          vy:=j+y;
          level.npcmap[vx,vy]:=0;
          level.map[i+x,j+y]:=12;
          Create_Explo(otstyp+(i+x)*wblock,otstyp+(j+y)*hblock,1);
          level.visible[i+x,j+y]:=true;
        end
       else level.visible[i+x,j+y]:=true;
end;

function Sum_mines(x,y:LongInt):LongInt;
var i,j,v:LongInt;
begin
  v:=0;
  for i:=-1 to 1 do
    for j:=-1 to 1 do
      if (j<>0)or(i<>0) then
        if (not level.visible[i+x,j+y])or(level.map[i+x,j+y]=10) then inc(v);
  Sum_mines:=v;
end;


begin
  if level.npcway[level.npcway[0]]<>0 then
    begin
      i:=(level.npcway[level.npcway[0]] div 100)*2;
      j:=(level.npcway[level.npcway[0]] mod 100)*2;
      if level.visible[i,j] and level.visible[i+1,j] and level.visible[i,j+1]
      and level.visible[i+1,j+1] and (level.npcmap[i,j]<>10) and (level.npcmap[i+1,j]<>10)
      and (level.npcmap[i,j+1]<>10) and (level.npcmap[i+1,j+1]<>10) then
      begin
        npc.x:=otstyp+i*wblock;npc.y:=otstyp+j*hblock;
        inc(level.npcway[0]);
        dec(npc.points,move_time);
        inc(pause,1000);
      end
    end;
  for x:=1 to 16*16 do
    begin
      if npc.points<=0 then exit;
      i:=level.queue[x] div 100;
      j:=level.queue[x] mod 100;
      if (i=50) then break;
      if not level.visible[i,j] then continue;
      if(level.npcmap[i,j]<>0)and(Sum_mines(i,j)=level.npcmap[i,j]) then
          begin
            dec(npc.points,deactivation_time*sum_mines(i,j));
            Clear_around(i,j);
            Update_map;
          end;

      if (level.npcmap[i,j]=0) then
      begin
        dec(npc.points,sum_mines(i,j)*goodtest_time);
        writeln(i,' ',j,' ',sum_mines(i,j),' ',npc.points);
        inc(pause,250*sum_mines(i,j));
        level.visible[i+1,j]:=true;
        level.visible[i-1,j]:=true;
        level.visible[i,j+1]:=true;
        level.visible[i,j-1]:=true;
        level.visible[i+1,j+1]:=true;
        level.visible[i+1,j-1]:=true;
        level.visible[i-1,j+1]:=true;
        level.visible[i-1,j-1]:=true;
        if pause<>0 then exit;
      end;

    end;
    Update_map;
    if npc.points>0 then

  if level.npcway[level.npcway[0]]<>0 then
    begin
      i:=(level.npcway[level.npcway[0]] div 100)*2;
      j:=(level.npcway[level.npcway[0]] mod 100)*2;
      begin
        npc.x:=otstyp+i*wblock;npc.y:=otstyp+j*hblock;
        inc(level.npcway[0]);
        dec(npc.points,move_time);
        inc(pause,1000);
          level.visible[i,j]:=true;
          level.visible[i+1,j]:=true;
          level.visible[i,j+1]:=true;
          level.visible[i+1,j+1]:=true;
        if (level.npcmap[i,j] div 10)+(level.npcmap[i+1,j] div 10)
        +(level.npcmap[i+1,j+1] div 10)+(level.npcmap[i,j+1] div 10)>0
        then begin
          dec(npc.points,activation_time);
          Create_Explo(npc.x,npc.y,2);
          level.npcmap[i,j]:=0;
          level.npcmap[i+1,j]:=0;
          level.npcmap[i+1,j+1]:=0;
          level.npcmap[i,j+1]:=0;
          update_map;
          if level.map[i,j]=10 then
            level.map[i,j]:=12;

          if level.map[i+1,j]=10 then
            level.map[i+1,j]:=12;

          if level.map[i,j+1]=10 then
            level.map[i,j+1]:=12;

          if level.map[i+1,j+1]=10 then
            level.map[i+1,j+1]:=12;
          end;
      end;
    end;
end;

procedure Next_Hod;
begin
  if (player.doing<>0)or(npc.doing<>0) then exit;
  if now_play=2 then
  inc(player.points,len_hod)
  else inc(npc.points,len_hod);
  if player.points>len_hod then player.points:=len_hod;
  if npc.points>len_hod then npc.points:=len_hod;
  now_play:=(now_play mod 2)+1;
end;


procedure Process(var player:TPlayer);
var x,y:LongInt;
begin
  if pause>0 then begin dec(pause,timerTick);exit;end;
  if ((now_play=2)and(type_game=1)) then
  begin
    Process_NPC;
    if pause<>0 then exit;
    if npc.points<=0 then
    Next_hod;
  end;
  if key_down(k_escape) then halt;
    If (player.doing=0)and(player.points>=move_time) then
    begin
      if ((key_down(k_left))or(key_down(k_a)))and(player.x>otstyp) then player.doing:=2;
      if ((key_down(k_right))or(key_down(k_d)))and(player.x<1024-wblock*2-otstyp) then player.doing:=4;
      if ((key_down(k_up))or(key_down(k_w)))and(player.y>otstyp)  then player.doing:=1;
      if ((key_down(k_down))or(key_down(k_s)))and(player.y<768-hblock*2-otstyp) then player.doing:=3;
      if player.doing<>0 then  dec(player.points,move_time);
      case player.doing of
      1:player.last_move:=0;
      2:player.last_move:=3;
      3:player.last_move:=2;
      4:player.last_move:=1;
      end;
    end;
    case player.doing of
    1:dec(player.y,2);
    2:dec(player.x,2);
    3:inc(player.y,2);
    4:inc(player.x,2);
    end;
    if ((player.x-otstyp) mod (wblock*2)=0)and((player.y-otstyp) mod (hblock*2)=0) then begin player.doing:=0;TestPlayerPosition(player);end;
    if ((mouse_click(M_BRIGHT))and(player.points>=deactivation_time)) then
    begin
     if (abs(mouse_x-player.x-wblock)>=wblock*3)or((abs(mouse_y-player.y-hblock)>=hblock*3)) then exit;
      x:=(mouse_x-otstyp) div wblock;
      y:=(mouse_y-otstyp) div hblock;
      dec(player.points,deactivation_time);
      if level.map[x,y]=10 then begin level.map[x,y]:=12;level.npcmap[x,y]:=0;
      Create_explo(otstyp+(mouse_x-otstyp) div wblock*wblock,otstyp+(mouse_y-otstyp) div hblock*hblock,1); Create_Explo(otstyp+x*wblock,otstyp+y*hblock,1);Update_map;end;
      level.visible[x,y]:=true;
    end;
    if (mouse_click(M_BLEFT))and(player.points>=goodtest_time) then
    begin
      if (abs(mouse_x-player.x-wblock)>=wblock*3)or((abs(mouse_y-player.y-hblock)>=hblock*3)) then exit;
      x:=(mouse_x-otstyp) div wblock;
      y:=(mouse_y-otstyp) div hblock;
      level.visible[x,y]:=true;
      if level.map[x,y]=10 then begin dec(player.points,badtest_time);level.map[x,y]:=12;
      Create_Explo(otstyp+(mouse_x-otstyp) div wblock*wblock,otstyp+(mouse_y-otstyp) div hblock*hblock,1);
      level.npcmap[x,y]:=0;Update_Map;end
      else dec(player.points,goodtest_time);
    end;
    if key_up(k_space) then Next_Hod;

  mouse_clearstate;
  key_clearstate;
end;

procedure Process_;
begin
  if key_up(k_r) then begin LoadLevel(type_game);scene:='game';end;
  if scene='game' then
  begin
   if key_up(k_r) then LoadLevel(type_game);
    if (now_play=1)or(type_game=1) then Process(player)
    else Process(npc);
    if (player.x=goal_x)and(player.y=goal_y) then win(1);
    if (npc.x=goal_x)and(npc.y=goal_y) then win(2);
  end
  else
  begin
  process_menu;
  end;
  key_clearstate;
end;
//*********************************************************************
//*********************************************************************
//*********************************************************************
procedure Paint;
var i,j:LongInt;
begin
if scene='game' then
begin
     for i:=15 downto 0 do
    for j:=15 downto 0 do
    begin
      if (i mod 2=0)and(j mod 2=0) then
          if ((i+j) mod 4=0) then
          pr2d_rect(otstyp+i*wblock,otstyp+j*hblock,wblock*2,hblock*2,$00ff00,255,PR2D_FILL)
          else  pr2d_rect(otstyp+i*wblock,otstyp+j*hblock,wblock*2,hblock*2,$ff0000,255,PR2D_FILL);
   end;

   for i:=15 downto 0 do
    for j:=15 downto 0 do
    begin

      if level.visible[i,j] then
    case level.map[i,j] of
     0:ssprite2d_draw(null,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     1:ssprite2d_draw(one,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     2:ssprite2d_draw(two,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     3:ssprite2d_draw(three,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     4:ssprite2d_draw(four,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     11:ssprite2d_draw(act_mine,otstyp+i*wblock,otstyp+j*hblock,wblock*2,hblock*2,0);
     12:ssprite2d_draw(deact_mine,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
     15:ssprite2d_draw(act_mine,otstyp+i*wblock,otstyp+j*hblock,wblock,hblock,0);
   end;
   end;
 if player.last_move mod 2=0 then
 ssprite2d_draw(player.texture,player.x,player.y,wblock*2,hblock*2,(player.last_move)*90)
 else  ssprite2d_draw(player.texture,player.x+(wblock-hblock),player.y-(wblock-hblock),hblock*2,wblock*2,(player.last_move)*90);
 if npc.last_move mod 2=0 then
 ssprite2d_draw(npc.texture,npc.x,npc.y,wblock*2,hblock*2,npc.last_move*90)
 else
 ssprite2d_draw(npc.texture,npc.x+(wblock-hblock),npc.y-(wblock-hblock),hblock*2,wblock*2,npc.last_move*90);

 ssprite2d_draw(goal_texture,goal_x,goal_y,wblock*2,hblock*2,0);
 pr2d_rect(mouse_x-5,mouse_y-5,5,5,$0000ff);
 for i:=1 to 8 do
   if player.points>=i then
     ssprite2d_draw(lamp_on,(1024 div 8)*(i-1),0,1024 div 8,otstyp,0)
     else ssprite2d_draw(lamp_off,(1024 div 8)*(i-1),0,1024 div 8,otstyp,0);
  for i:=1 to 8 do
   if npc.points>=i then
     ssprite2d_draw(lamp_on,(1024 div 8)*(i-1),768-otstyp,1024 div 8,otstyp,0)
     else ssprite2d_draw(lamp_off,(1024 div 8)*(i-1),768-otstyp,1024 div 8,otstyp,0);

 for i:=1 to 25 do
   if explo[i].frame<=8 then
     asprite2d_draw(explo_texture,explo[i].x,explo[i].y,wblock*explo[i].mult,hblock*explo[i].mult,0,explo[i].frame);
end
else
begin
  ssprite2d_draw(background_menu,0,0,1024,768,0);
  if not need_enter then
  begin
    ssprite2d_draw(pb_button,0,250,500,200,0);
    ssprite2d_draw(pp_button,0,400,500,200,0);
    ssprite2d_draw(exit_button,0,550,500,200,0);
  end;
  pr2d_rect(mouse_x-5,mouse_y-5,10,10,$00ff00);
end;
end;
//*********************************************************************
//*********************************************************************
//*********************************************************************
procedure InitNPC;
var x1,x2,x,y,y1,y2,r,u,cr,cu,i,j,v:LongInt;
map:array[-1..16,-1..16] of LongInt;
function min(a,b:LongInt):LongInt;
begin
  if a>b then min:=b
  else min:=a;
end;

begin

  for i:=-1 to 16 do
    for j:=-1 to 16 do
      map[i,j]:=10000;

  x1:=(npc.x-otstyp)div (2*wblock);
  x2:=(goal_x-otstyp) div (2*wblock);

  y1:=(npc.y-otstyp) div (2*hblock);
  y2:=(goal_y-otstyp)div(2*hblock);

  if x1<x2 then r:=1 else r:=-1;
  if y1<y2 then u:=1 else u:=-1;
  cr:=abs(x2-x1);
  cu:=abs(y2-y1);
  x:=x1;y:=y1;
  fillchar(level.npcway,sizeof(level.npcway),0);
  level.npcway[0]:=1;
  repeat
    if cr<>0 then begin
    inc(x,r);dec(cr);
    level.npcway[level.npcway[0]]:=x*100+y;
    inc(level.npcway[0]);
    map[x*2,y*2]:=0;
    map[x*2+1,y*2]:=0;
    map[x*2,y*2+1]:=0;
    map[x*2+1,y*2+1]:=0;
    end;

    if cu<>0 then begin
    inc(y,u);dec(cu);
    level.npcway[level.npcway[0]]:=x*100+y;
    map[x*2,y*2]:=0;
    map[x*2+1,y*2]:=0;
    map[x*2,y*2+1]:=0;
    map[x*2+1,y*2+1]:=0;
    inc(level.npcway[0]);
    end;
  until (cr+cu=0);
  level.npcway[0]:=1;

  for x:=1 to 32+1 do
   for i:=0 to 15 do
     for j:=0 to 15 do
     begin
      map[i,j]:=
     min(map[i,j]-1,min( min(map[i-1,j],map[i+1,j]),min(map[i,j+1],map[i,j-1])))+1;
      end;
  x:=0;
  for v:=0 to 2 do
    for i:=0 to 15 do
      for j:=0 to 15 do
        if map[i,j]=v then
      begin
        inc(x);
        level.queue[x]:=i*100+j;
      end;
end;

procedure LoadResourses;
begin
  player.texture:=Tex_LoadFromFIle('./pictures\hero1.png',$000000,TEX_DEFAULT_2D or FX_BLEND);
  one:=Tex_LoadFromFIle('./pictures\1.png',$fffff1,TEX_DEFAULT_2D or FX_BLEND);
  two:=Tex_LoadFromFIle('./pictures\2.png',$fffff1,TEX_DEFAULT_2D or FX_BLEND);
  three:=Tex_LoadFromFIle('./pictures\3.png',$fffff1,TEX_DEFAULT_2D or FX_BLEND);
  four:=Tex_LoadFromFIle('./pictures\4.png',$fffff1,TEX_DEFAULT_2D or FX_BLEND);
  npc.texture:=Tex_LoadFromFIle('./pictures\hero2.png',$000000,TEX_DEFAULT_2D or FX_BLEND);
  deact_mine:=Tex_LoadFromFIle('./pictures\mine_deactivated.png',$fffff3,TEX_DEFAULT_2D or FX_BLEND);
  goal_texture:=Tex_LoadFromFIle('./pictures\goal.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  null:=Tex_LoadFromFIle('./pictures\0.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  explo_texture:=Tex_LoadFromFIle('./pictures\explo.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  tex_SetFrameSize(explo_texture,64,64);
  background_menu:=Tex_LoadFromFIle('./pictures\menu.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  pb_button:=Tex_LoadFromFIle('./pictures\pvb.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  pp_button:=Tex_LoadFromFIle('./pictures\pvp.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  exit_button:=Tex_LoadFromFIle('./pictures\exit.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);

  p1_win:=Tex_LoadFromFIle('./pictures\Pl1win.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  p2_win:=Tex_LoadFromFIle('./pictures\Pl2win.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  c_win:=Tex_LoadFromFIle('./pictures\lose.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  lamp_on:=Tex_LoadFromFIle('./pictures\lamp_on.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);
  lamp_off:=Tex_LoadFromFIle('./pictures\lamp_off.png',$ffff3f,TEX_DEFAULT_2D or FX_BLEND);

end;

procedure LoadLevel(t:LongInt);
var s,v:string;i,j,x:LongInt; map:array[1..8,1..8] of boolean;
begin
  v:=chr(game.level+ord('0'));
  type_game:=t;
  now_play:=1;
  fillchar(level.map,sizeof(level.map),0);
  fillchar(map,sizeof(map),false);
  fillchar(level.visible,sizeof(level.visible),0);
  fillchar(level.npcmap,sizeof(level.npcmap),0);
  fillchar(explo,sizeof(explo),0);

  s:='./levels\level'+v+'.txt';
  assign(input,s);
  reset(input);
  read(level.count_mines,player.x,player.y,npc.x,npc.y,goal_x,goal_y);
  map[player.x,player.y]:=true;
  map[npc.x,npc.y]:=true;
  map[goal_x,goal_y]:=true;

  i:=npc.x*2;j:=npc.y*2;
  level.visible[i,j-1]:=true;
  level.visible[i-1,j-1]:=true;
  level.visible[i+1,j-1]:=true;
  level.visible[i-1,j]:=true;
  level.visible[i+2,j]:=true;
  level.visible[i+2,j-1]:=true;
  level.visible[i-1,j+1]:=true;
  level.visible[i+2,j+1]:=true;
  level.visible[i-1,j+2]:=true;
  level.visible[i+2,j+2]:=true;
  level.visible[i,j+2]:=true;
  level.visible[i+1,j+2]:=true;


  i:=player.x*2;j:=player.y*2;
  level.visible[i,j-1]:=true;
  level.visible[i-1,j-1]:=true;
  level.visible[i+1,j-1]:=true;
  level.visible[i-1,j]:=true;
  level.visible[i+2,j]:=true;
  level.visible[i+2,j-1]:=true;
  level.visible[i-1,j+1]:=true;
  level.visible[i+2,j+1]:=true;
  level.visible[i-1,j+2]:=true;
  level.visible[i+2,j+2]:=true;
  level.visible[i,j+2]:=true;
  level.visible[i+1,j+2]:=true;


  player.x:=player.x*wblock*2+otstyp;
  player.y:=player.y*hblock*2+otstyp;
  npc.x:=npc.x*wblock*2+otstyp;
  npc.y:=npc.y*hblock*2+otstyp;
  goal_x:=goal_x*wblock*2+otstyp;
  goal_y:=goal_y*hblock*2+otstyp;
  close(input);
  x:=0;
  while x<=level.count_mines do
  begin
    i:=random(16);
    j:=random(16);
    if map[(i div 2),(j div 2)]=false then begin map[(i div 2),(j div 2)]:=true; inc(x);level.map[i,j]:=10;end;
  end;
  for i:=0 to 15 do
    for j:=0 to 15 do
      if level.map[i,j]<>10 then
        level.map[i,j]:=level.map[i-1,j] div 10+level.map[i+1,j] div 10+level.map[i,j-1] div 10+level.map[i,j+1] div 10
      +level.map[i-1,j-1] div 10+level.map[i+1,j-1] div 10+level.map[i-1,j+1] div 10+level.map[i+1,j+1] div 10;

 level.npcmap:=level.map;
   InitNPC;
 for i:=0 to 7 do
   for j:=0 to 7 do
     if (level.map[i*2,j*2] div 10)+(level.map[i*2+1,j*2+1] div 10)+
     (level.map[i*2+1,j*2] div 10)+(level.map[i*2,j*2+1] div 10)>1 then halt;


  player.points:=len_hod;
  npc.points:=len_hod;
  TestPlayerPosition(npc);
 end;

procedure Init;
begin
  OGGINIT(FINDWINDOW(nil,'Game'));
  pause:=0;
  randomize;

  LoadResourses;

  //
    assign(input,'./options.ini');
    reset(input);
      read(len_hod,goodtest_time,badtest_time,activation_time,deactivation_time,move_time);
    close(input);
  //

  player.points:=len_hod;
  npc.points:=len_hod;

{  Snd_Init;    }                                   {
  music:=Snd_LoadFromFile('./music.ogg',1);}
  {Snd_Play(music,0,0,0);}   {
  music._file:=' ';
  Snd_PlayFile(music);      }
  music.Free;
  music:=TOGG.Create('./music.ogg');
  scene:='menu';
  need_enter:=false;

end;


begin
  zglLoad(Libzengl);
  timer_Add(@Process_,TimerTick);
  timer_Add(@Explo_process,1500 div 8);


  zgl_reg(SYS_DRAW,@Paint);
  zgl_reg(SYS_LOAD,@Init);
  wnd_setCaption('Game');

  scr_SetOptions(1024,768,32,0,false,false);

  zgl_init;


end.
